'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultConfig = exports.isHostAllowed = undefined;

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isHostAllowed = exports.isHostAllowed = (config, host) => (0, _get2.default)(config, 'allowRegexes').reduce((accumulator, currentRe) => accumulator || currentRe.test(host), false);

const commaDelimit = arr => (arr || []).join(',');

const defaultConfig = exports.defaultConfig = {
  allowRegexes: [/^http.*$/],
  allowMethods: commaDelimit(['GET', 'POST', 'PUT']),
  allowHeaders: commaDelimit(['Content-Type', 'X-Amz-Date', 'Authorization', 'X-Api-Key', 'X-Amz-Security-Token']),
  exposeHeaders: commaDelimit([]),
  maxAge: 86400,
  allowCredentials: true
};