'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _pickBy = require('lodash/pickBy');

var _pickBy2 = _interopRequireDefault(_pickBy);

var _corsConfig = require('./corsConfig');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const pickTruthyValues = obj => (0, _pickBy2.default)(obj, value => value);

const getCorsPreflightResponse = (config, host) => ({
  headers: pickTruthyValues({
    'Access-Control-Allow-Origin': host,
    'Access-Control-Allow-Methods': config.allowMethods,
    'Access-Control-Allow-Headers': config.allowHeaders,
    'Access-Control-Max-Age': config.maxAge
  }),
  statusCode: 200
});

const corsResponseMiddleware = (config = _corsConfig.defaultConfig) => next => event => {
  const host = (0, _get2.default)(event, 'headers.origin');
  if (event.httpMethod === 'OPTIONS' && (0, _corsConfig.isHostAllowed)(config, host)) {
    return Promise.resolve(getCorsPreflightResponse(config, host));
  }
  return next(event);
};

exports.default = corsResponseMiddleware;