'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _pickBy = require('lodash/pickBy');

var _pickBy2 = _interopRequireDefault(_pickBy);

var _corsConfig = require('./corsConfig');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const pickTruthyValues = obj => (0, _pickBy2.default)(obj, value => value);

const getCorsResponseHeaders = (response, host, config) => pickTruthyValues(_extends({
  'Access-Control-Allow-Origin': host,
  'Access-Control-Allow-Credentials': true,
  'Access-Control-Expose-Headers': config.exposeHeaders
}, response.headers || {}));

const corsResponseMiddleware = (config = _corsConfig.defaultConfig) => next => event => {
  const host = (0, _get2.default)(event, 'headers.origin');
  if (!(0, _corsConfig.isHostAllowed)(config, host)) {
    return next(event);
  }
  return next(event).then(response => _extends({}, response, {
    headers: getCorsResponseHeaders(response, host, config)
  }));
};

exports.default = corsResponseMiddleware;