import get from 'lodash/get';
import fs from 'fs';

export const isHostAllowed = (config, host) =>
  get(config, 'allowRegexes').reduce(
    (accumulator, currentRe) => accumulator || currentRe.test(host),
    false
  );

const commaDelimit = arr => (arr || []).join(',');

export const defaultConfig = ({
  allowRegexes: [/^http.*$/],
  allowMethods: commaDelimit(['GET', 'POST', 'PUT']),
  allowHeaders: commaDelimit([
    'Content-Type',
    'X-Amz-Date',
    'Authorization',
    'X-Api-Key',
    'X-Amz-Security-Token'
  ]),
  exposeHeaders: commaDelimit([]),
  maxAge: 86400,
  allowCredentials: true
});
