import corsPreflightMiddleware from './corsPreflightMiddleware';

test('corsPreflightMiddleware happy OPTIONS request', () => {
  expect.assertions(1);
  const event = {
    headers: {
      origin: 'https://www.seek.com.au'
    },
    httpMethod: 'OPTIONS'
  };
  const differentResp = {
    statusCode: 204,
    body: 'No content'
  };
  return corsPreflightMiddleware()(e => Promise.resolve(differentResp))(
    event
  ).then(response => {
    expect(response).toEqual({
      statusCode: 200,
      headers: {
        'Access-Control-Allow-Headers':
          'Content-Type,X-Amz-Date,Authorization,X-Api-Key,X-Amz-Security-Token',
        'Access-Control-Allow-Methods': 'GET,POST,PUT',
        'Access-Control-Allow-Origin': 'https://www.seek.com.au',
        'Access-Control-Max-Age': 86400
      }
    });
  });
});
